/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : skarms.c
Last edit : 10/20/92
Created   :
Version   : 1.2

History   :

Does      :
*/
#include <stdlib.h>
#include <curses.h>

#include <paths.h>

/* Companion I, Skill at arms and skill at magic. 
   Player is allowed to roll twice from this table for
   one background point. Previous roll is ignored. 
*/

extern char *get_word(FILE *);

char *skarms(int *statti, int *bonus)
{
  char arms[45][40];		/* 43 different arms specialities. */
  int  wbonus[4];		/* weapon bonuses. */
  int  wrajat[6];		/* ranges for them. */
  int  i=0;			/* loop encounter. */
  FILE *src=NULL;		/* Source filehandle, for tables. */
  char name[80];		/* Filename of table. */
  char puskuri[100];		/* Tempory string-workspace. */
  int rolli=0;			/* The die. */
  int sw=0;			/* Stat for weapon. */
  int b=0;			/* Bonus. */
  int w;			/* Weapon bonus. */
  char snames[10][3]={"CO","SD","AG","MQ","RE","ST","QU","PR","IN","EM"};
  char *a;

  /* Filename generation. */
  src = fopen(SKILLATA,"r");
  if(!src) {
    perror("skarms.c/fopen()");
    exit(0);
  }

  /* Skill at arms. */
  for(i=1;i<45;i++) 
    sprintf(arms[i],"%s",get_word(src));

  /* Bonuses. */
  for(i=0;i<3;i++) {
    a = get_word(src);
    wrajat[i]=atoi(a);      
    a = get_word(src);
    wbonus[i]=atoi(a);
  }	  
  fclose(src);

  rolli = sattuma(1,100);

  if(rolli < 44) {
    move(20,0); 
    printw("You got:");
    attron(A_BOLD);
    printw("%s. ",arms[rolli]);
    attroff(A_BOLD);
    printw("Press any key to continue.");
    refresh();
    getch();
    move(20,0);
    clrtoeol();
    refresh();
    return arms[rolli];
  }
  else {
    w = 0;
    while(rolli >wrajat[w])w++;
    b = wbonus[w];
    sw = sattuma(0,4);
    switch(sw) {
      case 0:
        sw = 5;
        break;
      case 1:
        sw = 6;
        break;
      case 2:
        sw = 0;
        break;
      case 3:
        sw = 2;
        break;
      case 4:
        sw = 1;
        break;
    }
     
    move(20,0); 
    printw("You got:");
    attron(A_BOLD);
    printw("+%i bonus at %s. ",wbonus[w],snames[sw]);
    attroff(A_BOLD);
    printw("Press any key to continue.");
    refresh();
    getch();
    move(20,0);
    clrtoeol();
    refresh();
    *bonus = wbonus[w];
    *statti = sw;
    return NULL;	        	
  }
}

#ifdef MAIN
void main()
{
  int a,b;

  initscr();
  siemen();
  skarms(&a,&b);
  endwin();
}
#endif  

   
